package jp.hishidama.javadb.tool;

import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.List;

import javax.swing.table.DefaultTableModel;

import jp.hishidama.javadb.tool.schema.DerbySchemaFrame;

public class ToolUtil {

	public static void addTableModelColumn(DefaultTableModel model,
			ResultSetMetaData md, List<Class<?>> classList) throws SQLException {
		StringBuilder sb = new StringBuilder(64);

		int size = md.getColumnCount();
		for (int i = 1; i <= size; i++) {

			String name = md.getColumnName(i);
			String type = md.getColumnTypeName(i);
			int csize = md.getPrecision(i);
			int scale = md.getScale(i);
			sb.setLength(0);
			sb.append("<html>");
			sb.append(name);
			sb.append("<br>");
			sb.append(type);
			sb.append("(");
			sb.append(csize);
			if (scale != 0) {
				sb.append(",");
				sb.append(scale);
			}
			sb.append(")</head>");
			model.addColumn(sb.toString());

			Class<?> cls;
			String className = md.getColumnClassName(i);
			ClassLoader loader = Thread.currentThread().getContextClassLoader();
			try {
				cls = loader.loadClass(className);
				// cls = Class.forName(className);
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
				DerbySchemaFrame.log(new ClassNotFoundException("column="
						+ name + " class=" + className, e));
				cls = Object.class;
			}
			classList.add(cls);
		}
	}
}
