package jp.hishidama.javadb.tool.conn;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Statement;

import jp.hishidama.javadb.tool.schema.DerbySchemaFrame;

public class DelegateStatement implements Statement {

	Statement stat;

	DelegateStatement(Statement stat) {
		this.stat = stat;
	}

	public void addBatch(String sql) throws SQLException {
		stat.addBatch(sql);
	}

	public void cancel() throws SQLException {
		stat.cancel();
	}

	public void clearBatch() throws SQLException {
		stat.clearBatch();
	}

	public void clearWarnings() throws SQLException {
		stat.clearWarnings();
	}

	public void close() throws SQLException {
		stat.close();
	}

	public boolean execute(String sql, int autoGeneratedKeys)
			throws SQLException {
		DerbySchemaFrame.logln("Statement#execute: " + sql);
		return stat.execute(sql, autoGeneratedKeys);
	}

	public boolean execute(String sql, int[] columnIndexes) throws SQLException {
		DerbySchemaFrame.logln("Statement#execute: " + sql);
		return stat.execute(sql, columnIndexes);
	}

	public boolean execute(String sql, String[] columnNames)
			throws SQLException {
		DerbySchemaFrame.logln("Statement#execute: " + sql);
		return stat.execute(sql, columnNames);
	}

	public boolean execute(String sql) throws SQLException {
		DerbySchemaFrame.logln("Statement#execute: " + sql);
		return stat.execute(sql);
	}

	public int[] executeBatch() throws SQLException {
		DerbySchemaFrame.logln("Statement#executeBatch()");
		return stat.executeBatch();
	}

	public ResultSet executeQuery(String sql) throws SQLException {
		DerbySchemaFrame.logln("Statement#executeQuery: " + sql);
		return stat.executeQuery(sql);
	}

	public int executeUpdate(String sql, int autoGeneratedKeys)
			throws SQLException {
		DerbySchemaFrame.logln("Statement#executeUpdate: " + sql);
		return stat.executeUpdate(sql, autoGeneratedKeys);
	}

	public int executeUpdate(String sql, int[] columnIndexes)
			throws SQLException {
		DerbySchemaFrame.logln("Statement#executeUpdate: " + sql);
		return stat.executeUpdate(sql, columnIndexes);
	}

	public int executeUpdate(String sql, String[] columnNames)
			throws SQLException {
		DerbySchemaFrame.logln("Statement#executeUpdate: " + sql);
		return stat.executeUpdate(sql, columnNames);
	}

	public int executeUpdate(String sql) throws SQLException {
		DerbySchemaFrame.logln("Statement#executeUpdate: " + sql);
		return stat.executeUpdate(sql);
	}

	public Connection getConnection() throws SQLException {
		return stat.getConnection();
	}

	public int getFetchDirection() throws SQLException {
		return stat.getFetchDirection();
	}

	public int getFetchSize() throws SQLException {
		return stat.getFetchSize();
	}

	public ResultSet getGeneratedKeys() throws SQLException {
		return stat.getGeneratedKeys();
	}

	public int getMaxFieldSize() throws SQLException {
		return stat.getMaxFieldSize();
	}

	public int getMaxRows() throws SQLException {
		return stat.getMaxRows();
	}

	public boolean getMoreResults() throws SQLException {
		return stat.getMoreResults();
	}

	public boolean getMoreResults(int current) throws SQLException {
		return stat.getMoreResults(current);
	}

	public int getQueryTimeout() throws SQLException {
		return stat.getQueryTimeout();
	}

	public ResultSet getResultSet() throws SQLException {
		return stat.getResultSet();
	}

	public int getResultSetConcurrency() throws SQLException {
		return stat.getResultSetConcurrency();
	}

	public int getResultSetHoldability() throws SQLException {
		return stat.getResultSetHoldability();
	}

	public int getResultSetType() throws SQLException {
		return stat.getResultSetType();
	}

	public int getUpdateCount() throws SQLException {
		return stat.getUpdateCount();
	}

	public SQLWarning getWarnings() throws SQLException {
		return stat.getWarnings();
	}

	public boolean isClosed() throws SQLException {
		return stat.isClosed();
	}

	public boolean isPoolable() throws SQLException {
		return stat.isPoolable();
	}

	public boolean isWrapperFor(Class<?> iface) throws SQLException {
		return stat.isWrapperFor(iface);
	}

	public void setCursorName(String name) throws SQLException {
		stat.setCursorName(name);
	}

	public void setEscapeProcessing(boolean enable) throws SQLException {
		stat.setEscapeProcessing(enable);
	}

	public void setFetchDirection(int direction) throws SQLException {
		stat.setFetchDirection(direction);
	}

	public void setFetchSize(int rows) throws SQLException {
		stat.setFetchSize(rows);
	}

	public void setMaxFieldSize(int max) throws SQLException {
		stat.setMaxFieldSize(max);
	}

	public void setMaxRows(int max) throws SQLException {
		stat.setMaxRows(max);
	}

	public void setPoolable(boolean poolable) throws SQLException {
		stat.setPoolable(poolable);
	}

	public void setQueryTimeout(int seconds) throws SQLException {
		stat.setQueryTimeout(seconds);
	}

	public <T> T unwrap(Class<T> iface) throws SQLException {
		return stat.unwrap(iface);
	}
}
