package jp.hishidama.javadb.tool.conn;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import jp.hishidama.javadb.tool.schema.DerbySchemaFrame;

public abstract class ExecuteQuery {

	public void start(String sql) {
		try {
			Connection conn = ConnManager.getConnection();

			Statement stat = conn.createStatement();
			try {
				ResultSet rs = stat.executeQuery(sql);
				try {
					processResultSet(rs);
				} finally {
					rs.close();
				}
			} finally {
				stat.close();
			}
		} catch (RuntimeException e) {
			DerbySchemaFrame.log(e);
			throw e;
		} catch (Exception e) {
			DerbySchemaFrame.log(e);
			throw new RuntimeException(e);
		}
	}

	protected void processResultSet(ResultSet rs) throws SQLException {
		while (rs.next()) {
			setResultSet(rs);
		}
	}

	protected abstract void setResultSet(ResultSet rs) throws SQLException;

}
