package jp.hishidama.javadb.tool.free;

import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.table.DefaultTableModel;

import jp.hishidama.javadb.tool.ToolUtil;

public class FreeDataModel extends DefaultTableModel {
	private static final long serialVersionUID = 1L;

	List<Class<?>> classList = new ArrayList<Class<?>>();

	public void initColumns(ResultSetMetaData md) throws SQLException,
			ClassNotFoundException {
		removeAllColumns();

		ToolUtil.addTableModelColumn(this, md, classList);
	}

	protected void removeAllColumns() {
		setRowCount(0);
		setColumnCount(0);
		classList.clear();
	}

	@Override
	public Class<?> getColumnClass(int mc) {
		if (mc < 0 || mc >= classList.size()) {
			return Object.class;
		}
		return classList.get(mc);
	}
}
