package jp.hishidama.javadb.tool.schema;

import java.awt.Font;

import javax.swing.JPopupMenu;
import javax.swing.text.JTextComponent;

import jp.hishidama.swing.popup.ExPopupMenu;
import jp.hishidama.swing.text.ExTextPane;
import jp.hishidama.swing.text.TextManager;
import jp.hishidama.swing.text.VisibleCaret;

public class SchemaTextPane extends ExTextPane {
	private static final long serialVersionUID = 1755942952328296496L;

	public SchemaTextPane() {
		setEditable(false);
		Font f = getFont();
		setFont(new Font(Font.MONOSPACED, Font.PLAIN, f.getSize()));

		setCaret(new VisibleCaret(getCaret().getBlinkRate()));
	}

	@Override
	protected TextManager createDefaultTextManager() {
		return new SchemaTextManager();
	}

	static class SchemaTextManager extends TextManager {

		SchemaTextManager() {
			setEnableUndoManager(false);
		}

		@Override
		protected JPopupMenu createPopupMenu(final JTextComponent tc) {
			return new ExPopupMenu(tc) {
				private static final long serialVersionUID = -5949610791441663957L;

				@Override
				protected void addMenus() {
					addCopy();
					addSelectAll();
				}
			};
		}

	}
}
