package jp.hishidama.javadb.tool.table;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.GroupLayout.ParallelGroup;
import javax.swing.GroupLayout.SequentialGroup;

import jp.hishidama.swing.radio.ExButtonGroup;
import jp.hishidama.swing.text.ExTextArea;

public class DerbyDataDialog extends JDialog {
	private static final long serialVersionUID = -6722320800593179381L;

	private JRadioButton r1 = new JRadioButton("l");
	private JRadioButton r2 = new JRadioButton("null");
	private JRadioButton r3 = new JRadioButton("default");
	private JRadioButton r4 = new JRadioButton("g֐");
	private ExTextArea t1 = new ExTextArea();
	private ExTextArea t4 = new ExTextArea();
	private JCheckBox h1 = new JCheckBox();
	private JScrollPane st1;
	private JScrollPane st4;
	private JButton b1 = new JButton(new OkAction());
	private JButton b2 = new JButton(new CancelAction());

	private boolean minimumInited = false;

	private DerbyGenericEditor editor;

	public DerbyDataDialog(JFrame owner) {
		super(owner, true);
		setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);

		r1.setToolTipText("<html>e[uɓl𒼐ڎw肷<br>"
				+ "JDBCɂĂPreparedStatement́u?vgēB</html>");
		r2.setToolTipText("nullig֐ŁunullvƓ͂̂Ɠj");
		r3.setToolTipText("defaultig֐ŁudefaultvƓ͂̂Ɠj");
		r4.setToolTipText("<html>e[uɓ鎮w肷<br>" + "Fcurrent_date()<br>"
				+ "JDBCɂĒڂ̎SQLɓB</html>");

		new ExButtonGroup(r1, r2, r3, r4);

		setSize(256 - 16, 192 - 16);
		setLocationRelativeTo(owner);

		t1.setLineWrap(true);
		st1 = new JScrollPane(t1);

		t4.setLineWrap(true);
		st4 = new JScrollPane(t4);
	}

	public void init(String title, DerbyGenericEditor editor) {
		setTitle(title);
		this.editor = editor;

		// t1.setText("");
		// t4.setText("");

		Container c = getContentPane();
		c.removeAll();

		JPanel p1 = new JPanel();
		GroupLayout layout = new GroupLayout(p1);
		p1.setLayout(layout);

		layout.setAutoCreateGaps(true);
		layout.setAutoCreateContainerGaps(true);

		JComponent c1;
		if (Boolean.class.isAssignableFrom(editor.dataClass)) {
			c1 = h1;
		} else {
			c1 = st1;
			// if (Number.class.isAssignableFrom(editor.dataClass)) {
			// t1.setHorizontalAlignment(JTextField.RIGHT);
			// } else {
			// t1.setHorizontalAlignment(JTextField.LEFT);
			// }
		}

		String text = editor.text.getText();
		t1.setText(text);
		t4.setText(text);
		h1.setSelected(editor.check.isSelected());
		if (editor.keyword) {
			if (text == null || "null".equals(text)) {
				r2.setSelected(true);
			} else if ("default".equals(text)) {
				r3.setSelected(true);
			} else {
				r4.setSelected(true);
			}
		} else {
			r1.setSelected(true);
		}

		// ̃O[v
		{
			SequentialGroup hg = layout.createSequentialGroup();
			ParallelGroup pg;

			pg = layout.createParallelGroup().addComponent(r1).addComponent(r2)
					.addComponent(r3).addComponent(r4);
			hg.addGroup(pg);
			pg = layout.createParallelGroup().addComponent(c1)
					.addComponent(st4);
			hg.addGroup(pg);

			layout.setHorizontalGroup(hg);
		}
		// ̃O[v
		{
			SequentialGroup vg = layout.createSequentialGroup();
			ParallelGroup pg;

			pg = layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
					.addComponent(r1).addComponent(c1);
			vg.addGroup(pg);
			pg = layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
					.addComponent(r2);
			vg.addGroup(pg);
			pg = layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
					.addComponent(r3);
			vg.addGroup(pg);
			pg = layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
					.addComponent(r4).addComponent(st4);
			vg.addGroup(pg);

			layout.setVerticalGroup(vg);
		}

		JPanel p2 = new JPanel(new FlowLayout());
		p2.add(b1);
		p2.add(b2);

		c.add(p1, BorderLayout.CENTER);
		c.add(p2, BorderLayout.PAGE_END);

		if (!minimumInited) {
			Dimension sz = c.getPreferredSize();
			sz.width += 32;
			sz.height += 24;
			setMinimumSize(sz);

			minimumInited = true;
		}
	}

	public void clearUndoEdit() {
		t1.setText("");
		t4.setText("");
		t1.clearUndoEdit();
		t4.clearUndoEdit();
	}

	class OkAction extends AbstractAction {
		private static final long serialVersionUID = -6277088356532374065L;

		public OkAction() {
			super("OK");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			setVisible(false);
			// dispose();

			if (r1.isSelected()) {
				editor.text.setText(t1.getText());
				editor.check.setSelected(h1.isSelected());
				editor.keyword = false;
			} else {
				String text;
				if (r2.isSelected()) {
					text = "null";
				} else if (r3.isSelected()) {
					text = "default";
				} else {
					text = t4.getText();
				}
				editor.text.setText(text);
				editor.keyword = true;
			}
			editor.dialoged = true;

			editor.changePanel();
			editor.panel.revalidate();
			editor.panel.repaint();
		}
	}

	class CancelAction extends AbstractAction {
		private static final long serialVersionUID = 1413924099161740759L;

		public CancelAction() {
			super("cancel");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			setVisible(false);
			// dispose();
		}
	}
}
