package jp.hishidama.javadb.tool.table;

import javax.swing.JTable;
import javax.swing.table.JTableHeader;

import jp.hishidama.swing.table.FitHeader;

class TableDefTable extends JTable {
	private static final long serialVersionUID = -5313811194027832920L;

	public TableDefTable(TableName tableName) {
		super(new TableDefModel(tableName));
		setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		setAutoCreateRowSorter(true);

		setColumnSelectionAllowed(true);
		setRowSelectionAllowed(true);

		FitHeader header = getTableHeader();
		header.sizeWidthToFitDataAll();

		setComponentPopupMenu(new CopyPopupMenu(this));

		setDragEnabled(true);
	}

	@Override
	public TableDefModel getModel() {
		return (TableDefModel) super.getModel();
	}

	@Override
	protected JTableHeader createDefaultTableHeader() {
		return new FitHeader(super.columnModel);
	}

	@Override
	public FitHeader getTableHeader() {
		return (FitHeader) super.getTableHeader();
	}
}
