package jp.hishidama.javadb.tool.table;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;

import javax.swing.table.DefaultTableModel;

import jp.hishidama.javadb.tool.conn.ConnManager;
import jp.hishidama.javadb.tool.schema.DerbySchemaFrame;

class TableKeyModel extends DefaultTableModel {
	private static final long serialVersionUID = 4558808669360878693L;

	protected TableName tableName;

	public TableKeyModel(TableName tableName) {
		this.tableName = tableName;
		addColumn("COLUMN_NAME");
		addColumn("KEY_SEQ");
		addColumn("PK_NAME");
	}

	public void load() {
		try {
			Connection conn = ConnManager.getConnection();

			DatabaseMetaData dmd = conn.getMetaData();
			ResultSet rs = dmd.getPrimaryKeys(null, tableName.getSchemaName(),
					tableName.getTableName());
			try {
				while (rs.next()) {
					String kname = rs.getString("PK_NAME");
					String cname = rs.getString("COLUMN_NAME");
					short seq = rs.getShort("KEY_SEQ");
					addRow(new Object[] { cname, seq, kname });
				}
			} finally {
				rs.close();
			}
		} catch (Exception e) {
			DerbySchemaFrame.log(e);
		}
	}

	@Override
	public boolean isCellEditable(int row, int column) {
		return false;
	}
}