package jp.hishidama.javadb.tool.table;

import javax.swing.JScrollPane;
import javax.swing.JSplitPane;

import jp.hishidama.javadb.tool.table.DerbyTableFrame.BeforeVisible;
import jp.hishidama.swing.table.RowHeaderTable;

class TableKeyPane extends JSplitPane implements BeforeVisible {
	private static final long serialVersionUID = -378389006879746909L;

	private TableKeyTable keyTable;
	private TableBestTable bestTable;

	public TableKeyPane(TableName tableName) {
		super(JSplitPane.VERTICAL_SPLIT);

		keyTable = new TableKeyTable(tableName);
		JScrollPane keyScroll = new JScrollPane(keyTable);
		new RowHeaderTable(keyTable, "", 48).installTo(keyScroll);
		keyScroll.setToolTipText("<html>vC}L[<br>"
				+ "DatabaseMetaData#getPrimaryKeys()Q</html>");
		bestTable = new TableBestTable(tableName);
		JScrollPane bestScroll = new JScrollPane(bestTable);
		new RowHeaderTable(bestTable, "", 48).installTo(bestScroll);
		bestScroll.setToolTipText("<html>R[hł鍀ځB<br>"
				+ "Aj[NL[ꍇ͕KR[hłƂ͌ȂB<br>"
				+ "DatabaseMetaData#getBestRowIdentifier()Q</html>");

		add(keyScroll);
		add(bestScroll);
		setDividerSize(4);
		setDividerLocation(256);
	}

	@Override
	public void beforeVisible() {
		keyTable.beforeVisible();
		bestTable.beforeVisible();
	}
}