package jp.hishidama.javadb.tool.table;

import javax.swing.JTable;
import javax.swing.table.JTableHeader;

import jp.hishidama.javadb.tool.table.DerbyTableFrame.BeforeVisible;
import jp.hishidama.swing.table.FitHeader;

class TableKeyTable extends JTable implements BeforeVisible {
	private static final long serialVersionUID = 8178863081269704669L;

	boolean loaded = false;

	public TableKeyTable(TableName tableName) {
		super(new TableKeyModel(tableName));
		setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		setAutoCreateRowSorter(true);

		setColumnSelectionAllowed(true);
		setRowSelectionAllowed(true);

		setComponentPopupMenu(new CopyPopupMenu(this));

		setDragEnabled(true);
	}

	@Override
	public TableKeyModel getModel() {
		return (TableKeyModel) super.getModel();
	}

	@Override
	protected JTableHeader createDefaultTableHeader() {
		return new FitHeader(super.columnModel);
	}

	@Override
	public FitHeader getTableHeader() {
		return (FitHeader) super.getTableHeader();
	}

	@Override
	public void beforeVisible() {
		if (!loaded) {
			getModel().load();

			FitHeader header = getTableHeader();
			header.sizeWidthToFitDataAll();

			loaded = true;
		}
	}
}